#ifndef _LGI_IDE_H_
#define _LGI_IDE_H_

#ifdef WIN32
#include "resource.h"
#endif
#include "resdefs.h"

#define LgiIdeVer				0.0

#define M_APPEND_TEXT			(M_USER+1)

#define ICON_PROJECT			0
#define ICON_DEPENDANCY			1
#define ICON_FOLDER				2
#define ICON_SOURCE				3
#define ICON_HEADER				4
#define ICON_RESOURCE			5
#define ICON_GRAPHIC			6

#define CMD_NEW					0
#define CMD_OPEN				1
#define CMD_SAVE				2
#define CMD_CUT					3
#define CMD_COPY				4
#define CMD_PASTE				5
#define CMD_COMPILE				6
#define CMD_BUILD				7
#define CMD_STOP_BUILD			8
#define CMD_EXECUTE				9
#define CMD_DEBUG				10
#define CMD_BREAKPOINT			11
#define CMD_RESTART				12
#define CMD_KILL				13
#define CMD_STEP_INTO			14
#define CMD_STEP_OVER			15
#define CMD_STEP_OUT			16
#define CMD_RUN_TO				17
#define CMD_FIND_IN_FILES		18
#define CMD_SEARCH				19
#define CMD_SAVE_ALL			20

#define BUILD_TYPE_DEBUG		0
#define BUILD_TYPE_RELEASE		1

#define OPT_EditorFont			"EdFont"

class IdeDoc;
class IdeProject;

extern char AppName[];
extern char *FindHeader(char *Short, List<char> &Paths);
extern bool BuildHeaderList(char *Cpp, List<char> &Headers, List<char> &IncPaths, bool Recurse);

class AppWnd : public GWindow
{
	class AppWndPrivate *d;

public:
	AppWnd();
	~AppWnd();

	void SaveAll();
	void CloseAll();
	IdeDoc *OpenFile(char *FileName);
	IdeProject *OpenProject(char *FileName, bool Create = false, bool Dep = false);
	IdeProject *RootProject();
	int OnCommand(int Cmd, int Event, OsView Wnd);
	void OnDocDestroy(IdeDoc *Doc);
	void OnProjectDestroy(IdeProject *Proj);
	void OnFile(char *File, bool IsProject = false);
	IdeDoc *TopDoc();
	IdeDoc *FocusDoc();
	bool OnRequestClose(bool IsClose);
	void AppendOutput(char *Txt, int Channel);
	void UpdateState(int Debugging = -1, int Building = -1);
	void OnFindFinished();
	int OnEvent(GMessage *m);
	void OnReceiveFiles(List<char> &Files);
	int GetBuildMode();
	GTree *GetTree();
	ObjProperties *GetOptions();
};

#include "IdeDoc.h"
#include "IdeProject.h"
#include "FindInFiles.h"

#endif
