/// \file
/// \author Matthew Allen
#ifndef _GFILTER_UI_H_
#define _GFILTER_UI_H_

#include "GTree.h"

class GFilterViewPrivate;

enum GFilterNode
{
	LNODE_NULL,
	LNODE_AND,
	LNODE_OR,
	LNODE_COND,
	LNODE_NEW
};

class GFilterItem : public GTreeItem
{
	class GFilterItemPrivate *d;

protected:
	void _PourText(GdcPt2 &Size);
	void _PaintText(GSurface *pDC, COLOUR Fore, COLOUR Back);

public:
	GFilterItem(GFilterViewPrivate *Data, GFilterNode Node = LNODE_NEW);
	~GFilterItem();

	GFilterNode GetNode();
	void SetNode(GFilterNode n);

	void OnMouseClick(GMouse &m);
};

/// Filter user interface using a tree structure.
class GFilterView : public GTree
{
	class GFilterViewPrivate *d;

public:
	GFilterView();
	~GFilterView();

	bool ShowLegend();
	void ShowLegend(bool b);

	GRect &GetClient();
	void OnPaint(GSurface *pDC);
};

#endif