#ifndef _GMDI_H_
#define _GMDI_H_

class GMdiChild : public GLayout
{
	friend class GMdiParent;
	
	class GMdiChildPrivate *d;

public:
	GMdiChild();
	~GMdiChild();
	
	void OnPaint(GSurface *pDC);	
	void OnMouseClick(GMouse &m);
	void OnMouseMove(GMouse &m);
	void Raise();
	void Lower();
	GRect &GetClient();
	bool Pour();
	bool Attach(GView *p);
	int OnEvent(GMessage *m);
};

class GMdiParent : public GLayout
{
	class GMdiParentPrivate *d;

	GMdiChild *IsChild(GView *v);

public:
	GMdiParent();
	~GMdiParent();
	
	void OnPaint(GSurface *pDC);
	bool Attach(GView *p);
	bool OnViewMouse(GView *View, GMouse &m);
	bool OnViewKey(GView *View, GKey &Key);
	GRect NewPos();
	void OnChildrenChanged(GView *Wnd, bool Attaching);
};

#endif
