/// \file
/// \author Matthew Allen (fret@memecode.com)
/// /brief A progress control

#ifndef _GPROGRESS_H_
#define _GPROGRESS_H_

/// Progress bar control
class LgiClass GProgress :
	public GControl,
	public Progress,
	public ResObject
{
	#if !defined WIN32
	COLOUR c;
	#endif

public:
	GProgress(int id, int x, int y, int cx, int cy, char *name);
	~GProgress();

	/// Sets the range that the Value() is between
	void SetLimits(int l, int h);
	/// Sets the point between the limits that defines where the progress is up to
	void Value(int v);
	int Value();
	int OnEvent(GMessage *Msg);

	#ifndef WIN32
	void GetLimits(int &l, int &h);
	void OnPaint(GSurface *pDC);
	void Colour(COLOUR Col);
	COLOUR Colour();
	#endif
};

#endif
