/// \file
/// \author Matthew Allen
/// \brief A text label

#ifndef _GTEXT_LABEL_H_
#define _GTEXT_LABEL_H_

/// A static text label widget
class LgiClass GText :
	public GView,
	public ResObject
{
	class GTextPrivate *d;

public:
	/// Constructor
	GText
	(
		/// The control's ID
		int id,
		/// Left edge position
		int x,
		/// Top edge position
		int y,
		/// The width
		int cx,
		/// The height
		int cy,
		/// Utf-8 text for the label
		char *name
	);
	~GText();

	/// Set the text
	bool Name(char *n);
	/// Set the text with a wide string
	bool NameW(char16 *n);
	/// Sets the font used to render the text
	void SetFont(GFont *Fnt, bool OwnIt = false);

	/// Returns the numeric value of the text (atoi)
	int Value();
	/// Sets the text to a number
	void Value(int i);
	/// Gets the text
	char *Name() { return GView::Name(); }
	/// Gets the text as a wide string
	char16 *NameW() { return GView::NameW(); }
	/// Background colour
	COLOUR Background();
	/// Background colour
	void Background(COLOUR c);
	/// Word wrap
	bool GetWrap();
	/// Sets the use of word wrap
	void SetWrap(bool b);
	
	// Events
	void OnPaint(GSurface *pDC);
	void OnPosChange();
};

#endif
