

#ifndef __PROGRESS_H
#define __PROGRESS_H

#include "GSemaphore.h"

/////////////////////////////////////////////////////////////////////////////////////////
class LgiClass Progress : public GSemaphore {
protected:
	char *Description;
	int Start;
	int Val;
	int Low, High;
	char *Type;
	double Scale;
	bool Canceled;

public:
	uint64 UserData;
	
	Progress();
	Progress(char *desc, int l, int h, char *type = NULL, double scale = 1.0);
	virtual ~Progress();

	virtual char *GetDescription() { return Description; }
	virtual void SetDescription(char *d = 0);
	virtual void GetLimits(int *l, int *h);
	virtual void SetLimits(int l, int h);
	virtual int Value() { return Val; }
	virtual void Value(int v) { Val = v; }
	virtual double GetScale() { return Scale; }
	virtual void SetScale(double s) { Scale = s; }
	virtual char *GetType() { return Type; }
	virtual void SetType(char *t) { Type = t; }
	
	virtual bool Cancel() { return Canceled; }
	virtual void Cancel(bool i) { Canceled = i; }
	virtual void SetParameter(int Which, int What) {}

	virtual Progress &operator =(Progress &p);
};


#endif
