
#ifndef __QScrollBar_h
#define __QScrollBar_h

#include "qwidget.h"

class QScrollBar : public QWidget
{
	class QScrollBarPrivate *d;

public:
	enum Orientation
	{
		Vertical,
		Horizontal
	};

	QScrollBar(QWidget *p = 0, char *name = 0);
	~QScrollBar();

	// Api
	Orientation orientation();
	void setOrientation(Orientation o);
	int value();
	void setValue(int v);
	int minValue();
	int maxValue();
	void setRange(int min, int max);
	int pageStep();
	void setPageStep(int i);

	// Impl
	void paintEvent(QEvent *e);
	void resizeEvent(QEvent *e);
	void mousePressEvent(QEvent *e);
	void mouseReleaseEvent(QEvent *e);
	void mouseMoveEvent(QEvent *e);
	void keyPressEvent(QEvent *e);
	void wheelEvent(QEvent *e);
};

#endif
