#include <stdlib.h>
#include <stdio.h>

#include "Lgi.h"
#include "GAbout.h"
#include "GDocView.h"
#include "GBitmap.h"
#include "GButton.h"

//////////////////////////////////////////////////////////////////////////////
#define IDM_WEB				100
#define IDM_BMP				101
#define IDM_MESSAGE			102

GAbout::GAbout(	GView *parent,
				char *AppName,
				double Ver,
				char *Text,
				char *AboutGraphic)
{
	SetParent(parent);
	if (NOT AppName) AppName = "Application";

	char Str[512];
	sprintf(Str, "About %s", AppName);
	Name(Str);

	#ifdef _DEBUG
	char *Build = "Debug";
	#else
	char *Build = "Release";
	#endif

	sprintf(Str,
			"%s v%02.2f (%s %s)\n"
			"Build: %s, %s\n"
			"\n"
			"Homepage:\n"
			"\thttp://www.memecode.com\n"
			"Email:\n"
			"\tfret@memecode.com\n",
			AppName,
			Ver,
			LgiGetOsName(),
			Build,
			__DATE__,
			__TIME__);
	if (Text)
	{
		strcat(Str, Text);
	}

	GView *Img = 0;
	int x = 10;
	if (AboutGraphic)
	{
		char *FileName = LgiFindFile(AboutGraphic);
		if (FileName)
		{
			Children.Insert(Img = NEW(GBitmap(IDM_BMP, 4, 4, FileName, true)));
			DeleteArray(FileName);
			x += 10 + Img->X();
			Img->Sunken(true);
			Img->SetNotify(this);
		}
	}

	GRect p(x, 10, x+190, 145);
	GView *Ctrl = GViewFactory::Create("GTextView3");
	if (NOT Ctrl) Ctrl = GViewFactory::Create("GTextView2");
	if (Ctrl)
	{
		Children.Insert(Ctrl);
		if (Ctrl)
		{
			GRect r(p.x1, p.y1, 1000, 500);

			Ctrl->SetId(IDM_MESSAGE);
			Ctrl->SetPos(r);
			Ctrl->SetNotify(this);
			Ctrl->Name(Str);

			GFontType Type;
			Type.GetSystemFont("System");
			GFont *f = Type.Create();
			if (f)
			{
				Ctrl->SetFont(f);
				DeleteObj(f);
			}

			GDocView *View = dynamic_cast<GDocView*>(Ctrl);
			if (View)
			{
				View->SetBackColour(LC_MED);
				View->SetReadOnly(true);
				View->SetCursor(strlen(Str), false);

				int x = 0, y = 0;
				View->GetTextExtent(x, y);
				x += 4;
				y += 4;
				x = max(x, 100);
				if (Img) y = max(y, Img->Y() - 30);
				
				p.Dimension(x-1, y-1);
				Ctrl->SetPos(p);
			}
		}
	}

	GRect BtnPos(p.x2 - 60, p.y2 + 10, p.x2, p.y2 + 30);
	Children.Insert(NEW(GButton(IDOK, BtnPos.x1, BtnPos.y1, BtnPos.X(), BtnPos.Y(), "Ok")));

	p.ZOff(BtnPos.x2 + 20, BtnPos.y2 + 40);
	SetPos(p);
	MoveToCenter();

	DoModal();
}

int GAbout::OnNotify(GView *Ctrl, int Flags)
{
	if (NOT Ctrl) return 0;
	
	switch (Ctrl->GetId())
	{
		case IDM_BMP:
		{
			GView *Bmp = FindControl(IDM_BMP);
			GView *Text = FindControl(IDM_MESSAGE);
			GView *Btn = FindControl(IDOK);
			if (Bmp AND Text AND Btn)
			{
				GRect b = Bmp->GetPos();
				GRect t = Text->GetPos();
				GRect c = Btn->GetPos();
				
				t.Offset(b.x2 + 10 - t.x1, 0);
				GRect p = GetPos();
				p.Dimension(t.x2 + 20, max(b.y2, t.y2+30) + 40);
				c.Offset(t.x2 - c.X() - c.x1, p.Y() - 60 - c.y1);

				Text->SetPos(t, true);
				Btn->SetPos(c, true);
				SetPos(p, true);
			}
			break;
		}
		case IDOK:
		{
			EndModal(0);
			break;
		}
	}
	return 0;
}

