/*hdr
**      FILE:           GuiCommon.cpp
**      AUTHOR:         Matthew Allen
**      DATE:           18/7/98
**      DESCRIPTION:    Common windows and controls
**
**      Copyright (C) 1998, Matthew Allen
**              fret@memecode.com
*/

#include <stdio.h>
#include "Lgi.h"
#include "GTextLabel.h"
#include "GEdit.h"
#include "GButton.h"

//////////////////////////////////////////////////////////////////////////////
GInput::GInput(GView *parent, char *InitStr, char *Msg, char *Title, bool Password)
{
	GRect r(0, 0, 295 + LgiApp->GetMetric(LGI_MET_DECOR_X), 90 + LgiApp->GetMetric(LGI_MET_DECOR_Y));
	Str = 0;

	SetParent(parent);
	Name(Title);
	SetPos(r);
	MoveToCenter();

	Children.Insert(NEW(GText(-1, 5, 5, 280, 20, Msg)));
	Children.Insert(Edit = NEW(GEdit(200, 5, 30, 280, 20, InitStr)));
	if (Edit)
	{
		Edit->Password(Password);
		Edit->Focus(true);
	}
	GButton *Ok = 0;
	Children.Insert(Ok = NEW(GButton(IDOK, 155, 60, 60, 20, "Ok")));
	Children.Insert(NEW(GButton(IDCANCEL, 225, 60, 60, 20, "Cancel")));

	if (Ok)
	{
		Ok->Default(true);
	}
}

GInput::~GInput()
{
	DeleteArray(Str);
}

int GInput::OnNotify(GView *Ctrl, int Flags)
{
	switch (Ctrl->GetId())
	{
		case IDOK:
		{
			Str = NewStr(Edit->Name());
			// fall thru
		}
		case IDCANCEL:
		{
			EndModal(Ctrl->GetId() == IDOK);
			break;
		}
	}

	return 0;
}

