#include <stdio.h>
#include "Lgi.h"
#include "../Mfs.h"

#define VER				1.0
char *AppName = "MfsTest";

class AppWnd : public GWindow
{
	MFileSystem Fs;

public:
	AppWnd()
	{
		Name(AppName);
		#ifdef WIN32
		CreateClass(AppName);
		#endif
		GRect r(0, 0, 800, 600);
		SetPos(r);
		MoveToCenter();
		SetQuitOnClose(true);

		if (Attach(0))
		{
			GSplitter *s = NEW(GSplitter);
			if (s)
			{
				s->Value(200);
				s->Border(false);
				s->Raised(false);
				s->Attach(this);
			}

			Visible(true);

			{
				char f[256];
				LgiGetExePath(f, sizeof(f));
				#ifdef WIN32
				LgiTrimDir(f);
				#endif
				LgiMakePath(f, sizeof(f), f, "test.mfs");
				
				// Open/Create the filesystem
				if (FileExists(f))
				{
					Fs.OpenSystem(f);
				}
				else
				{
					Fs.CreateNewSystem(f);
				}
			}

			// Do a file test..
			MFile *f = NEW(MFile(&Fs));
			if (f)
			{
				if (f->Open("/test.txt", O_WRITE))
				{
					if (f->GetSize() == 0)
					{
						f->Print("This is a test");
					}
					else
					{
						char Buf[256];
						int r = f->Read(Buf, sizeof(Buf));
					}
				}
				else
				{
					printf("%s:%i - open failed.\n", __FILE__, __LINE__);
				}
				
				DeleteObj(f);
			}
			else
			{
				printf("%s:%i - new failed.\n", __FILE__, __LINE__);
			}
		}
	}
};

int LgiMain(OsAppArguments &AppArgs)
{
	printf("MfsTest v%.2f\n", VER);

	GApp *a = NEW(GApp("application/mfstest", AppArgs));
	if (a AND
		a->IsOk())
	{
		NEW(AppWnd);
		a->Run();
		DeleteObj(a);
	}

	return 0;
}

