// BeOS Clipboard Implementation
#include "Lgi.h"

///////////////////////////////////////////////////////////////////////////////////////////////

GClipBoard::GClipBoard(GView *o)
{
	Owner = o;
	Open = false;
	Txt = 0;
	pDC = 0;
}

GClipBoard::~GClipBoard()
{
}

bool GClipBoard::Empty()
{
	bool Status = false;


	return Status;
}

#ifdef XWIN
void GClipBoard::OnEvent(XEvent *Event)
{
	if (Owner AND
		Event->xselection.type == SelectionNotify AND
		Event->xselection.requestor == Owner->Handle()->handle())
	{
		uchar *Data = 0;
		Atom Type = XInternAtom(XDisplay(), "UTF-8", false);;
		Atom ActualType = 0;
		int Format = 0;
		ulong Items = 0, Bytes = 0;
		
		if (XGetWindowProperty(	XDisplay(),
								Owner->Handle()->handle(),
								Event->xselection.property,
								0, // offset
								1024, // len
								true, // delete
								AnyPropertyType, // required type
								&ActualType,
								&Format,
								&Items,
								&Bytes,
								&Data) == XSuccess)
		{
			Txt = NewStr((char*)Data);
			XFree(Data);
		}
		
		GotEvent = true;
	}
}
#endif

bool GClipBoard::Text(char *Str, bool AutoEmpty)
{
	bool Status = false;

	if (AutoEmpty)
	{
		Empty();
	}
	
	if (Str AND Owner)
	{
		#if defined XWIN
		XSetSelectionOwner(XDisplay(), QApp()->GetClipboard(), Owner->Handle()->handle(), CurrentTime);
		QApp()->SetClipText(Owner->Handle(), Str);
		Status = true;
		#endif
	}

	return Status;
}

char *GClipBoard::Text()
{
	char *Status = 0;

	#if defined XWIN
	GotEvent = false;
	if (Owner)
	{
		Atom Clipboard	= QApp()->GetClipboard();
		Atom Utf8		= XInternAtom(XDisplay(), "UTF-8", false);
		Atom Utf8String = XInternAtom(XDisplay(), "UTF8_STRING", false);
		Atom Prop		= XInternAtom(XDisplay(), "_LGI_CLIPBOARD", false);
		Atom Targets	= XInternAtom(XDisplay(), "TARGETS", false);

		// Try and get a list of target types
		uchar *Data = 0;
		ulong Len = 0;
		Window OwnerWnd = Owner->Handle()->handle();
		if (QApplication::GetApp()->GetSelection(OwnerWnd, Clipboard, Utf8String, Data, Len) OR
			QApplication::GetApp()->GetSelection(OwnerWnd, Clipboard, Utf8, Data, Len))
		{
			Status = NewStr((char*)Data, Len);
			XFree(Data);
		}
	}
	#endif
	
	return Status;
}

bool GClipBoard::TextW(char16 *Str, bool AutoEmpty)
{
	bool Status = false;


	return Status;
}

char16 *GClipBoard::TextW()
{
	char16 *Status = 0;


	return Status;
}

bool GClipBoard::Bitmap(GSurface *pDC, bool AutoEmpty)
{
	bool Status = false;
	if (pDC AND Owner)
	{
		#if defined XWIN
		XSetSelectionOwner(XDisplay(), QApp()->GetClipboard(), Owner->Handle()->handle(), CurrentTime);
		QApp()->SetClipImage(Owner->Handle(), pDC);
		Status = true;
		#endif
	}
	return Status;
}

GSurface *GClipBoard::Bitmap()
{
	GSurface *pDC = false;

	#if defined XWIN
	GotEvent = false;
	if (Owner)
	{
		Atom Clipboard = QApp()->GetClipboard();
		Atom APixmap = XInternAtom(XDisplay(), "PIXMAP", false);

		// Try and get a list of target types
		uchar *Data = 0;
		ulong Len = 0;
		if (QApplication::GetApp()->GetSelection(Owner->Handle()->handle(), Clipboard, APixmap, Data, Len))
		{
			Pixmap p = ((Pixmap*)Data)[0];
			
			Window Root;
			int x, y, e;
			uint Width, Height, Border = 0, Depth = 0;
			if ((e = XGetGeometry(XDisplay(), p, &Root, &x, &y, &Width, &Height, &Border, &Depth)) == 1)
			{			
				XImage *Temp = XGetImage(XDisplay(), p, 0, 0, Width, Height, -1, ZPixmap);
				if (Temp)
				{
					pDC = NEW(GMemDC);
					if (pDC)
					{
						if (pDC->Create(Width, Height, GdcD->GetBits()))
						{
							memcpy( (*pDC)[0], Temp->data, Temp->bytes_per_line * Temp->height);
						}
						else
						{
							DeleteObj(pDC);
						}		
					}
					
					XDestroyImage(Temp);
				}
				else
				{
					printf("%s,%i - No image returned from XGetImage.\n", __FILE__, __LINE__);
				}
			}
			
			XFree(Data);
		}
		else
		{
			printf("%s,%i - Couldm't GetSelection.\n", __FILE__, __LINE__);
		}
	}
	#endif
	
	return pDC;
}

bool GClipBoard::Binary(int Format, uchar *Ptr, int Len, bool AutoEmpty)
{
	bool Status = false;

	if (Ptr AND Len > 0)
	{
	}

	return Status;
}

bool GClipBoard::Binary(int Format, uchar **Ptr, int *Len)
{
	bool Status = false;

	if (Ptr AND Len)
	{
	}

	return Status;
}

