#include "Lgi.h"
#include "GdiLeak.h"

class GPrintDCPrivate
{
public:
	bool PageOpen;
	bool DocOpen;

	GPrintDCPrivate()
	{
		PageOpen = false;
		DocOpen = false;
	}
};

GPrintDC::GPrintDC(void *Handle, char *PrintJobName)
{
	d = NEW(GPrintDCPrivate);
	hDC = (HDC) Handle;
	
	// Start document
	if (hDC)
	{
		DOCINFO Info;

		Info.cbSize = sizeof(DOCINFO); 
		Info.lpszDocName = PrintJobName ? PrintJobName : "Lgi Print Job"; 
		Info.lpszOutput = (LPTSTR) NULL; 
		Info.lpszDatatype = (LPTSTR) NULL; 
		Info.fwType = 0;

		d->DocOpen = StartDoc(hDC, &Info) > 0;
	}
}

GPrintDC::~GPrintDC()
{
	EndPage();

    if (hDC)
    {
		if (d->DocOpen)
		{
			EndDoc(hDC);
		}

	    DeleteDC(hDC);
		hDC = 0;
    }
}

int GPrintDC::X()
{
	return GetDeviceCaps(hDC, HORZRES);
}

int GPrintDC::Y()
{
	return GetDeviceCaps(hDC, VERTRES);
}

int GPrintDC::GetBits()
{
	return GetDeviceCaps(hDC, BITSPIXEL);
}

int GPrintDC::DpiX()
{
	return GetDeviceCaps(hDC, LOGPIXELSX); 
}

int GPrintDC::DpiY()
{
	return GetDeviceCaps(hDC, LOGPIXELSY);
}

bool GPrintDC::StartPage()
{
	bool Status = false;
	if (hDC AND d->DocOpen)
	{
		EndPage();
		Status = ::StartPage(hDC) > 0;
		if (Status)
		{
			d->PageOpen = true;
		}
	}

	return Status;
}

void GPrintDC::EndPage()
{
	if (hDC AND d->PageOpen)
	{
		::EndPage(hDC);
		d->PageOpen = false;
	}
}

