#include "Lgi.h"

//////////////////////////////////////////////////////////////////////////////
int GTrayIcon::TrayCreateMsg = 0;
// WM_TRAY_NOTIFY

GTrayIcon::GTrayIcon(GWindow *p)
{
	ZeroObj(TrayIcon);
	Parent = p;
	Val = 0;
	MyId = 0;
	TrayCreateMsg = RegisterWindowMessage(TEXT("TaskbarCreated"));
}

GTrayIcon::~GTrayIcon()
{
	for (HICON *i=Icon.First(); i; i=Icon.Next())
	{
		DeleteObject(*i);
	}

	Visible(false);
}

bool GTrayIcon::LoadIcon(char *Str)
{
	HICON i = ::LoadIcon(LgiProcessInst(), Str);
	if (i)
	{
		Icon.Insert(NEW(HICON(i)));
	}

	return false;
}

bool GTrayIcon::Visible()
{
	return TrayIcon.cbSize != 0;
}

void GTrayIcon::Visible(bool v)
{
	if (Visible() != v)
	{
		if (v)
		{
			static int Id = 1;
			HICON *Cur = Icon[Val];

			ZeroObj(TrayIcon);
			TrayIcon.cbSize = sizeof(TrayIcon);
			TrayIcon.hWnd = Parent ? Parent->Handle() : 0;
			TrayIcon.uID = MyId = Id++;
			TrayIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
			TrayIcon.uCallbackMessage = WM_TRAY_NOTIFY;
			TrayIcon.hIcon = Cur ? *Cur : 0;
			strncpy(TrayIcon.szTip, Name()?Name():"", sizeof(TrayIcon.szTip));

			Shell_NotifyIcon(NIM_ADD, &TrayIcon);
		}
		else
		{
			Shell_NotifyIcon(NIM_DELETE, &TrayIcon);
			ZeroObj(TrayIcon);
		}
	}
}

int GTrayIcon::Value()
{
	return Val;
}

void GTrayIcon::Value(int v)
{
	Val = v;

	if (Visible())
	{
		HICON *Cur = Icon[Val];

		ZeroObj(TrayIcon);
		TrayIcon.cbSize = sizeof(TrayIcon);
		TrayIcon.hWnd = Parent ? Parent->Handle() : 0;
		TrayIcon.uID = MyId;
		TrayIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
		TrayIcon.uCallbackMessage = WM_TRAY_NOTIFY;
		TrayIcon.hIcon = Cur ? *Cur : 0;
		strncpy(TrayIcon.szTip, Name(), sizeof(TrayIcon.szTip));

		Shell_NotifyIcon(NIM_MODIFY, &TrayIcon);
	}
}

int GTrayIcon::OnEvent(GMessage *Message)
{
	if (MsgCode(Message) == WM_TRAY_NOTIFY AND
		MsgA(Message) == MyId)
	{
		// got a notification from the icon
		GMouse m;
		ZeroObj(m);
		switch (MsgB(Message))
		{
			case WM_LBUTTONDBLCLK:
			case WM_RBUTTONDBLCLK:
			case WM_MBUTTONDBLCLK:
			{
				m.Down(true);
				m.Double(true);
				break;
			}
			case WM_LBUTTONDOWN:
			case WM_RBUTTONDOWN:
			case WM_MBUTTONDOWN:
			{
				m.Down(true);
				break;
			}
		}

		switch (MsgB(Message))
		{
			case WM_LBUTTONDBLCLK:
			case WM_LBUTTONDOWN:
			case WM_LBUTTONUP:
			{
				m.Left(true);
				break;
			}
			case WM_RBUTTONDBLCLK:
			case WM_RBUTTONDOWN:
			case WM_RBUTTONUP:
			{
				m.Right(true);
				break;
			}
			case WM_MBUTTONDBLCLK:
			case WM_MBUTTONDOWN:
			case WM_MBUTTONUP:
			{
				m.Middle(true);
				break;
			}
		}

		switch (MsgB(Message))
		{
			case WM_LBUTTONDBLCLK:
			case WM_RBUTTONDBLCLK:
			case WM_MBUTTONDBLCLK:
			{
				m.Double(true);
				break;
			}
		}

		if (Parent)
		{
			Parent->OnTrayClick(m);
		}
	}
	else if (MsgCode(Message) == TrayCreateMsg)
	{
		// explorer crashed... reinit the icon
		TrayIcon.cbSize = 0; // we're not visible
		Visible(true);
	}

	return 0;
}

