#include "Lgi.h"
#include <COMMCTRL.H>

///////////////////////////////////////////////////////////////////////////////////////////
GProgress::GProgress(int id, int x, int y, int cx, int cy, char *name) :
	GControl(LGI_PROGRESS),
	ResObject(Res_Progress)
{
	SetClass(LGI_PROGRESS);
	SetId(id);
	SetPos(GRect(x, y, x+cx, y+cy));
	if (name) GControl::Name(name);

	SetStyle(GetStyle() | WS_CHILD | WS_TABSTOP | WS_VISIBLE | PBS_SMOOTH);
	if (SubClass)
	{
		SubClass->SubClass(PROGRESS_CLASS);
	}
}

GProgress::~GProgress()
{
}

void GProgress::SetLimits(int l, int h)
{
	Low = l;
	High = h;
	if (Handle())
	{
		SendMessage(Handle(), PBM_SETRANGE32, Low, High);
	}
}

int GProgress::Value()
{
	return Val;
}

void GProgress::Value(int v)
{
	Val = v;
	if (Handle())
	{
		SendMessage(Handle(), PBM_SETPOS, (WPARAM) Val, 0);
	}
}

int GProgress::OnEvent(GMessage *Msg)
{
	return GControl::OnEvent(Msg);
}
